Loading...
Searching...
No Matches
Ogre::Skeleton Class Reference
Core » Animation

A collection of Bone objects used to animate a skinned mesh. More...

`#include <OgreSkeleton.h>`

Inheritance diagram for Ogre::Skeleton:
[legend]

## Public Types

typedef std::vector< ushort > | BoneHandleMap
| Map to translate bone handle from one skeleton to another skeleton.
typedef VectorIterator< BoneList > | BoneIterator
typedef std::vector< Bone * > | BoneList
typedef ConstVectorIterator< LinkedSkeletonAnimSourceList > | LinkedSkeletonAnimSourceIterator
typedef std::vector< LinkedSkeletonAnimationSource > | LinkedSkeletonAnimSourceList
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
Public Types inherited from Ogre::AnimationContainer
typedef std::map< String, Animation * > | AnimationList

## Public Member Functions

| Skeleton (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, don't call directly, use SkeletonManager.
virtual | ~Skeleton ()
virtual void | _buildMapBoneByHandle (const Skeleton *source, BoneHandleMap &boneHandleMap) const
| Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.
virtual void | _buildMapBoneByName (const Skeleton *source, BoneHandleMap &boneHandleMap) const
| Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.
virtual Animation * | _getAnimationImpl (const String &name, const LinkedSkeletonAnimationSource **linker=0) const
| Internal accessor for animations (returns null if animation does not exist).
void | _getBoneMatrices (Affine3 *pMatrices)
| Populates the passed in array with the bone matrices based on the current position.
virtual void | _initAnimationState (AnimationStateSet *animSet)
| Initialise an animation set suitable for use with this skeleton.
virtual void | _mergeSkeletonAnimations (const Skeleton *source, const BoneHandleMap &boneHandleMap, const StringVector &animations=StringVector())
| Merge animations from another Skeleton object into this skeleton.
virtual void | _notifyManualBonesDirty (void)
| Internal method for marking the manual bones as dirty.
virtual void | _notifyManualBoneStateChange (Bone *bone)
| Internal method for notifying that a bone is manual.
virtual void | _refreshAnimationState (AnimationStateSet *animSet)
| Refresh an animation set suitable for use with this skeleton.
virtual void | _updateTransforms (void)
| Updates all the derived transforms in the skeleton.
virtual void | addLinkedSkeletonAnimationSource (const String &skelName, Real scale=1.0f)
| Allows you to use the animations from another Skeleton object to animate this skeleton.
Animation * | createAnimation (const String &name, Real length) override
| Creates a new Animation object for animating this skeleton.
virtual Bone * | createBone (const String &name)
| Creates a brand new Bone owned by this Skeleton.
virtual Bone * | createBone (const String &name, unsigned short handle)
| Creates a brand new Bone owned by this Skeleton.
virtual Bone * | createBone (unsigned short handle)
| Creates a brand new Bone owned by this Skeleton.
virtual Bone * | createBone (void)
| Creates a brand new Bone owned by this Skeleton.
Animation * | getAnimation (const String &name) const override
| Returns the named Animation object.
virtual Animation * | getAnimation (const String &name, const LinkedSkeletonAnimationSource **linker) const
| Returns the named Animation object.
Animation * | getAnimation (unsigned short index) const override
| Gets a single animation by index.
SkeletonAnimationBlendMode | getBlendMode () const
| Gets the animation blending mode which this skeleton will use.
Bone * | getBone (const String &name) const
| Gets a bone by it's name.
Bone * | getBone (unsigned short handle) const
| Gets a bone by it's handle.
virtual BoneIterator | getBoneIterator (void)
| Get an iterator over all the bones in the skeleton.
const BoneList & | getBones () const
| Get all the bones in the skeleton.
virtual LinkedSkeletonAnimSourceIterator | getLinkedSkeletonAnimationSourceIterator (void) const
virtual const LinkedSkeletonAnimSourceList & | getLinkedSkeletonAnimationSources () const
| Get the linked skeletons used as animation sources.
virtual bool | getManualBonesDirty (void) const
| Have manual bones been modified since the skeleton was last updated?
unsigned short | getNumAnimations (void) const override
| Gets the number of animations in this container.
unsigned short | getNumBones (void) const
| Returns the number of bones in this skeleton.
virtual BoneIterator | getRootBoneIterator (void)
| Get an iterator over the root bones in the skeleton, ie those with no parents.
const BoneList & | getRootBones () const
| Get the root bones in the skeleton, ie those with no parents.
bool | hasAnimation (const String &name) const override
| Returns whether this object contains the named animation.
bool | hasBone (const String &name) const
| Returns whether this skeleton contains the named bone.
virtual bool | hasManualBones (void) const
| Are there any manually controlled bones?
virtual void | optimiseAllAnimations (bool preservingIdentityNodeTracks=false)
| Optimise all of this skeleton's animations.
virtual void | removeAllLinkedSkeletonAnimationSources (void)
| Remove all links to other skeletons for the purposes of sharing animation.
void | removeAnimation (const String &name) override
| Remove & destroy an Animation from this container.
void | reset (bool resetManualBones=false)
| Resets the position and orientation of all bones in this skeleton to their original binding position.
virtual void | setAnimationState (const AnimationStateSet &animSet)
| Changes the state of the skeleton to reflect the application of the passed in collection of animations.
void | setBindingPose (void)
| Sets the current position / orientation to be the 'binding pose' i.e.
void | setBlendMode (SkeletonAnimationBlendMode state)
| Sets the animation blending mode this skeleton will use.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
void | _fireLoadingComplete (bool unused=false)
| Firing of loading complete event.
void | _firePreparingComplete (bool unused=false)
| Firing of preparing complete event.
void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getGroup (void) const
| Gets the group which this resource is a member of.
ResourceHandle | getHandle (void) const
LoadingState | getLoadingState () const
| Returns the current loading state.
const String & | getName (void) const
| Gets resource name.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::AnimationContainer
virtual | ~AnimationContainer ()

## Additional Inherited Members

Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Detailed Description

A collection of Bone objects used to animate a skinned mesh.

Skeletal animation works by having a collection of 'bones' which are actually just joints with a position and orientation, arranged in a tree structure. For example, the wrist joint is a child of the elbow joint, which in turn is a child of the shoulder joint. Rotating the shoulder automatically moves the elbow and wrist as well due to this hierarchy.

  So how does this animate a mesh? Well every vertex in a mesh is assigned to one or more bones which affects it's position when the bone is moved. If a vertex is assigned to more than one bone, then weights must be assigned to determine how much each bone affects the vertex (actually a weight of 1.0 is used for single bone assignments). Weighted vertex assignments are especially useful around the joints themselves to avoid 'pinching' of the mesh in this region.

  Therefore by moving the skeleton using preset animations, we can animate the mesh. The advantage of using skeletal animation is that you store less animation data, especially as vertex counts increase. In addition, you are able to blend multiple animations together (e.g. walking and looking around, running and shooting) and provide smooth transitions between animations without incurring as much of an overhead as would be involved if you did this on the core vertex data.

  Skeleton definitions are loaded from datafiles, namely the .skeleton file format. They are loaded on demand, especially when referenced by a Mesh.

## Member Typedef Documentation

## BoneList

typedef std::vector<Bone*> Ogre::Skeleton::BoneList

## BoneIterator

typedef VectorIterator<BoneList> Ogre::Skeleton::BoneIterator

## LinkedSkeletonAnimSourceList

typedef std::vector<LinkedSkeletonAnimationSource> Ogre::Skeleton::LinkedSkeletonAnimSourceList

## LinkedSkeletonAnimSourceIterator

typedef ConstVectorIterator<LinkedSkeletonAnimSourceList> Ogre::Skeleton::LinkedSkeletonAnimSourceIterator

## BoneHandleMap

typedef std::vector<ushort> Ogre::Skeleton::BoneHandleMap

Map to translate bone handle from one skeleton to another skeleton.

## Constructor & Destructor Documentation

## Skeleton()

Ogre::Skeleton::Skeleton | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

Constructor, don't call directly, use SkeletonManager.

On creation, a Skeleton has a no bones, you should create them and link them together appropriately.

## ~Skeleton()

virtual Ogre::Skeleton::~Skeleton | ( |  | ) |

virtual

## Member Function Documentation

## createBone() [1/4]

virtual Bone * Ogre::Skeleton::createBone | ( | void |  | ) |

virtual

Creates a brand new Bone owned by this Skeleton.

This method creates an unattached new Bone for this skeleton. Unless this is to be a root bone (there may be more than one of these), you must attach it to another Bone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the Bone::createChild method instead, once you have created the root bone.

  Note that this method automatically generates a handle for the bone, which you can retrieve using Bone::getHandle. If you wish the new Bone to have a specific handle, use the alternate form of this method which takes a handle as a parameter, although you should note the restrictions.

## createBone() [2/4]

virtual Bone * Ogre::Skeleton::createBone | ( | unsigned short | handle | ) |

virtual

Creates a brand new Bone owned by this Skeleton.

This method creates an unattached new Bone for this skeleton and assigns it a specific handle. Unless this is to be a root bone (there may be more than one of these), you must attach it to another Bone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the Bone::createChild method instead, once you have created a root bone.

Parameters

  handle | The handle to give to this new bone - must be unique within this skeleton. You should also ensure that all bone handles are eventually contiguous (this is to simplify their compilation into an indexed array of transformation matrices). For this reason it is advised that you use the simpler createBone method which automatically assigns a sequential handle starting from 0.

## createBone() [3/4]

virtual Bone * Ogre::Skeleton::createBone | ( | const String & | name | ) |

virtual

Creates a brand new Bone owned by this Skeleton.

This method creates an unattached new Bone for this skeleton and assigns it a specific name.Unless this is to be a root bone (there may be more than one of these), you must attach it to another Bone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the Bone::createChild method instead, once you have created the root bone.

Parameters

  name | The name to give to this new bone - must be unique within this skeleton. Note that the way OGRE looks up bones is via a numeric handle, so if you name a Bone this way it will be given an automatic sequential handle. The name is just for your convenience, although it is recommended that you only use the handle to retrieve the bone in performance-critical code.

## createBone() [4/4]

virtual Bone * Ogre::Skeleton::createBone | ( | const String & | name,
|  | unsigned short | handle )

virtual

Creates a brand new Bone owned by this Skeleton.

This method creates an unattached new Bone for this skeleton and assigns it a specific name and handle. Unless this is to be a root bone (there may be more than one of these), you must attach it to another Bone in the skeleton using addChild for it to be any use. For this reason you will likely be better off creating child bones using the Bone::createChild method instead, once you have created the root bone.

Parameters

  name | The name to give to this new bone - must be unique within this skeleton.
  handle | The handle to give to this new bone - must be unique within this skeleton.

## getNumBones()

unsigned short Ogre::Skeleton::getNumBones | ( | void |  | ) | const

inline

Returns the number of bones in this skeleton.

## getRootBoneIterator()

virtual BoneIterator Ogre::Skeleton::getRootBoneIterator | ( | void |  | ) |

virtual

Get an iterator over the root bones in the skeleton, ie those with no parents.

Deprecated
  use Skeleton::getRootBones

## getRootBones()

const BoneList & Ogre::Skeleton::getRootBones | ( |  | ) | const

Get the root bones in the skeleton, ie those with no parents.

The system derives the root bone the first time you ask for it. The root bone is the only bone in the skeleton which has no parent. The system locates it by taking the first bone in the list and going up the bone tree until there are no more parents, and saves this top bone as the root. If you are building the skeleton manually using createBone then you must ensure there is only one bone which is not a child of another bone, otherwise your skeleton will not work properly. If you use createBone only once, and then use Bone::createChild from then on, then inherently the first bone you create will by default be the root.

## getBoneIterator()

virtual BoneIterator Ogre::Skeleton::getBoneIterator | ( | void |  | ) |

virtual

Get an iterator over all the bones in the skeleton.

Deprecated
  use getBones()

## getBones()

const BoneList & Ogre::Skeleton::getBones | ( |  | ) | const

inline

Get all the bones in the skeleton.

## getBone() [1/2]

Bone * Ogre::Skeleton::getBone | ( | unsigned short | handle | ) | const

inline

Gets a bone by it's handle.

## getBone() [2/2]

Bone * Ogre::Skeleton::getBone | ( | const String & | name | ) | const

Gets a bone by it's name.

## hasBone()

bool Ogre::Skeleton::hasBone | ( | const String & | name | ) | const

Returns whether this skeleton contains the named bone.

## setBindingPose()

void Ogre::Skeleton::setBindingPose | ( | void |  | ) |

Sets the current position / orientation to be the 'binding pose' i.e.

the layout in which bones were originally bound to a mesh.

## reset()

void Ogre::Skeleton::reset | ( | bool | resetManualBones = false | ) |

Resets the position and orientation of all bones in this skeleton to their original binding position.

A skeleton is bound to a mesh in a binding pose. Bone positions are then modified from this position during animation. This method returns all the bones to their original position and orientation.

Parameters

  resetManualBones | If set to true, causes the state of manual bones to be reset too, which is normally not done to allow the manual state to persist even when keyframe animation is applied.

## createAnimation()

Animation * Ogre::Skeleton::createAnimation | ( | const String & | name,
|  | Real | length )

override virtual

Creates a new Animation object for animating this skeleton.

Parameters

  name | The name of the animation, must be unique within this container.
  length | The length of the animation in seconds

Implements Ogre::AnimationContainer.

Reimplemented in Ogre::SkeletonInstance.

## getAnimation() [1/3]

virtual Animation * Ogre::Skeleton::getAnimation | ( | const String & | name,
|  | const LinkedSkeletonAnimationSource ** | linker ) const

virtual

Returns the named Animation object.

Will pick up animations in linked skeletons (

See also
  addLinkedSkeletonAnimationSource).

Parameters

  name | The name of the animation
  linker | Optional pointer to a pointer to the linked skeleton animation where this is coming from.

Reimplemented in Ogre::SkeletonInstance.

## getAnimation() [2/3]

Animation * Ogre::Skeleton::getAnimation | ( | const String & | name | ) | const

override virtual

Returns the named Animation object.

Will pick up animations in linked skeletons (

See also
  addLinkedSkeletonAnimationSource).

Parameters

  name | The name of the animation

Implements Ogre::AnimationContainer.

## _getAnimationImpl()

virtual Animation * Ogre::Skeleton::_getAnimationImpl | ( | const String & | name,
|  | const LinkedSkeletonAnimationSource ** | linker = 0 ) const

virtual

Internal accessor for animations (returns null if animation does not exist).

Reimplemented in Ogre::SkeletonInstance.

## hasAnimation()

bool Ogre::Skeleton::hasAnimation | ( | const String & | name | ) | const

override virtual

Returns whether this object contains the named animation.

Implements Ogre::AnimationContainer.

## removeAnimation()

void Ogre::Skeleton::removeAnimation | ( | const String & | name | ) |

override virtual

Remove & destroy an Animation from this container.

Implements Ogre::AnimationContainer.

Reimplemented in Ogre::SkeletonInstance.

## setAnimationState()

virtual void Ogre::Skeleton::setAnimationState | ( | const AnimationStateSet & | animSet | ) |

virtual

Changes the state of the skeleton to reflect the application of the passed in collection of animations.

Animating a skeleton involves both interpolating between keyframes of a specific animation, and blending between the animations themselves. Calling this method sets the state of the skeleton so that it reflects the combination of all the passed in animations, at the time index specified for each, using the weights specified. Note that the weights between animations do not have to sum to 1.0, because some animations may affect only subsets of the skeleton. If the weights exceed 1.0 for the same area of the skeleton, the movement will just be exaggerated.

## _initAnimationState()

virtual void Ogre::Skeleton::_initAnimationState | ( | AnimationStateSet * | animSet | ) |

virtual

Initialise an animation set suitable for use with this skeleton.

Only recommended for use inside the engine, not by applications.

Reimplemented in Ogre::SkeletonInstance.

## _refreshAnimationState()

virtual void Ogre::Skeleton::_refreshAnimationState | ( | AnimationStateSet * | animSet | ) |

virtual

Refresh an animation set suitable for use with this skeleton.

Only recommended for use inside the engine, not by applications.

Reimplemented in Ogre::SkeletonInstance.

## _getBoneMatrices()

void Ogre::Skeleton::_getBoneMatrices | ( | Affine3 * | pMatrices | ) |

Populates the passed in array with the bone matrices based on the current position.

Internal use only. The array pointed to by the passed in pointer must be at least as large as the number of bones. Assumes animation has already been updated.

## getNumAnimations()

unsigned short Ogre::Skeleton::getNumAnimations | ( | void |  | ) | const

override virtual

Gets the number of animations in this container.

Implements Ogre::AnimationContainer.

Reimplemented in Ogre::SkeletonInstance.

## getAnimation() [3/3]

Animation * Ogre::Skeleton::getAnimation | ( | unsigned short | index | ) | const

override virtual

Gets a single animation by index.

Will NOT pick up animations in linked skeletons (

See also
  addLinkedSkeletonAnimationSource).

Implements Ogre::AnimationContainer.

Reimplemented in Ogre::SkeletonInstance.

## getBlendMode()

SkeletonAnimationBlendMode Ogre::Skeleton::getBlendMode | ( |  | ) | const

inline

Gets the animation blending mode which this skeleton will use.

## setBlendMode()

void Ogre::Skeleton::setBlendMode | ( | SkeletonAnimationBlendMode | state | ) |

inline

Sets the animation blending mode this skeleton will use.

## _updateTransforms()

virtual void Ogre::Skeleton::_updateTransforms | ( | void |  | ) |

virtual

Updates all the derived transforms in the skeleton.

## optimiseAllAnimations()

virtual void Ogre::Skeleton::optimiseAllAnimations | ( | bool | preservingIdentityNodeTracks = false | ) |

virtual

Optimise all of this skeleton's animations.

See also
  Animation::optimise

Parameters

  preservingIdentityNodeTracks | If true, don't destroy identity node tracks.

## addLinkedSkeletonAnimationSource()

virtual void Ogre::Skeleton::addLinkedSkeletonAnimationSource | ( | const String & | skelName,
|  | Real | scale = 1.0f )

virtual

Allows you to use the animations from another Skeleton object to animate this skeleton.

If you have skeletons of identical structure (that means identically named bones with identical handles, and with the same hierarchy), but slightly different proportions or binding poses, you can re-use animations from one in the other. Because animations are actually stored as changes to bones from their bind positions, it's possible to use the same animation data for different skeletons, provided the skeletal structure matches and the 'deltas' stored in the keyframes apply equally well to the other skeletons bind position (so they must be roughly similar, but don't have to be identical). You can use the 'scale' option to adjust the translation and scale keyframes where there are large differences in size between the skeletons.

Note
  This method takes a skeleton name, rather than a more specific animation name, for two reasons; firstly it allows some validation of compatibility of skeletal structure, and secondly skeletons are the unit of loading. Linking a skeleton to another in this way means that the linkee will be prevented from being destroyed until the linker is destroyed.

You cannot set up cyclic relationships, e.g. SkeletonA uses SkeletonB's animations, and SkeletonB uses SkeletonA's animations. This is because it would set up a circular dependency which would prevent proper unloading - make one of the skeletons the 'master' in this case.

Parameters

  skelName | Name of the skeleton to link animations from. This skeleton will be loaded immediately if this skeleton is already loaded, otherwise it will be loaded when this skeleton is.
  scale | A scale factor to apply to translation and scaling elements of the keyframes in the other skeleton when applying the animations to this one. Compensates for skeleton size differences.

Reimplemented in Ogre::SkeletonInstance.

## removeAllLinkedSkeletonAnimationSources()

virtual void Ogre::Skeleton::removeAllLinkedSkeletonAnimationSources | ( | void |  | ) |

virtual

Remove all links to other skeletons for the purposes of sharing animation.

Reimplemented in Ogre::SkeletonInstance.

## getLinkedSkeletonAnimationSources()

virtual const LinkedSkeletonAnimSourceList & Ogre::Skeleton::getLinkedSkeletonAnimationSources | ( |  | ) | const

inline virtual

Get the linked skeletons used as animation sources.

Reimplemented in Ogre::SkeletonInstance.

## getLinkedSkeletonAnimationSourceIterator()

virtual LinkedSkeletonAnimSourceIterator Ogre::Skeleton::getLinkedSkeletonAnimationSourceIterator | ( | void |  | ) | const

virtual

Deprecated
  use getLinkedSkeletonAnimationSources

Reimplemented in Ogre::SkeletonInstance.

## _notifyManualBonesDirty()

virtual void Ogre::Skeleton::_notifyManualBonesDirty | ( | void |  | ) |

virtual

Internal method for marking the manual bones as dirty.

## _notifyManualBoneStateChange()

virtual void Ogre::Skeleton::_notifyManualBoneStateChange | ( | Bone * | bone | ) |

virtual

Internal method for notifying that a bone is manual.

## getManualBonesDirty()

virtual bool Ogre::Skeleton::getManualBonesDirty | ( | void |  | ) | const

inline virtual

Have manual bones been modified since the skeleton was last updated?

## hasManualBones()

virtual bool Ogre::Skeleton::hasManualBones | ( | void |  | ) | const

inline virtual

Are there any manually controlled bones?

## _mergeSkeletonAnimations()

virtual void Ogre::Skeleton::_mergeSkeletonAnimations | ( | const Skeleton * | source,
|  | const BoneHandleMap & | boneHandleMap,
|  | const StringVector & | animations = StringVector() )

virtual

Merge animations from another Skeleton object into this skeleton.

This function allow merge two structures compatible skeletons. The 'compatible' here means identically bones will have same hierarchy, but skeletons are not necessary to have same number of bones (if number bones of source skeleton's more than this skeleton, they will copied as is, except that duplicate names are disallowed; and in the case of bones missing in source skeleton, nothing happen for those bones).

  There are also unnecessary to have same binding poses, this function will adjust keyframes of the source skeleton to match this skeleton automatically.

  It's useful for exporting skeleton animations separately. i.e. export mesh and 'master' skeleton at the same time, and then other animations will export separately (even if used completely difference binding pose), finally, merge separately exported animations into 'master' skeleton.

Parameters

  source | Pointer to source skeleton. It'll keep unmodified.
  boneHandleMap | A map to translate identically bone's handle from source skeleton to this skeleton. If mapped bone handle doesn't exists in this skeleton, it'll created. You can populate bone handle map manually, or use predefined functions build bone handle map for you. (

See also
  _buildMapBoneByHandle, _buildMapBoneByName)

Parameters

  animations | A list name of animations to merge, if empty, all animations of source skeleton are used to merge. Note that the animation names must not presented in this skeleton, and will NOT pick up animations in linked skeletons (

See also
  addLinkedSkeletonAnimationSource).

## _buildMapBoneByHandle()

virtual void Ogre::Skeleton::_buildMapBoneByHandle | ( | const Skeleton * | source,
|  | BoneHandleMap & | boneHandleMap ) const

virtual

Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.

Identically bones are determine by handle.

## _buildMapBoneByName()

virtual void Ogre::Skeleton::_buildMapBoneByName | ( | const Skeleton * | source,
|  | BoneHandleMap & | boneHandleMap ) const

virtual

Build the bone handle map to use with Skeleton::_mergeSkeletonAnimations.

Identically bones are determine by name.

The documentation for this class was generated from the following file:

- OgreSkeleton.h